main/urls.py
from django.urls import path
from main.views import ai_solutions
from main.views.consulting import HomeView
from main.views.consulting import PostDetail
from main.views.consulting import CreatePost
from main.views.consulting import AddComment,shopping_carts
from main.views.consulting import Experts
from main.views.consulting import LikeView
from main.views.consulting import ReverseView
from main.views.consulting import SortedView
from main.views.consulting import HotView
from main.views.consulting import MyShare
from main.views.plant import my_plants
from main.views.plant import add_plants, manage_plants
from main.views.plant import diagnoseView
from main.views.plant import delete_plants

app_name = 'main'
urlpatterns = [
    path('', ai_solutions.index, name='index'),
    path('aisolutions/<int:page>/', ai_solutions.ai_solutions, name='ai_solutions'),
    path('aisolutions/smartcurtain/<int:page>/', ai_solutions.smart_curtain, name='smart_curtain'),
    path('aisolutions/virtualrealityforesttherapy/<int:page>/', ai_solutions.virtual_reality_forest_therapy, name='virtual_reality_forest_therapy'),
    path('aisolutions/virtualrealityforesttherapy/digital_twin/', ai_solutions.digital_twin, name='digital_twin'),
    path('aisolutions/virtualrealityforesttherapy/vr_detail/', ai_solutions.vr_detail, name='vr_detail'),


    #path('', HomeView.as_view(), name='index'),
    path('consulting/', HomeView.as_view(), name='consulting'),
    path('consulting/my_share', MyShare.as_view(), name='my_share'),
    path('consulting/<int:pk>/', PostDetail.as_view(), name='post_detail'),
    path('consulting/creatingPost/', CreatePost.as_view(), name='create_post'),
    path('consulting/<int:pk>/commentPost/', AddComment.as_view(), name='add_comment'),
    path('consulting/experts', Experts.as_view(), name='experts'),
    path('like/<int:pk>', LikeView, name='like_post'),
    path('consulting/', ReverseView.as_view(), name='reverse_post'),
    path('consulting/sorted/', SortedView.as_view(), name='sorted_post'),
    path('consulting/hot/', HotView.as_view(), name='hot_post'),
    path('my_plants/', my_plants.as_view(), name='my_plants'),
    path('manage_plants/<int:pk>/', manage_plants.as_view(), name='manage_plants'),
    path('add_plants/', add_plants.as_view(), name='add_plants'),
    path('diagnose/<int:pk>', diagnoseView, name='diagnose'),
    path('delete_plants/<int:pk>', delete_plants.as_view(), name='delete_plants'),
    path('shopping_carts/', shopping_carts.as_view(), name='shopping_carts'),
]

mysite/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
                path('', include('main.urls')),
                path('authentication/', include('authentication.urls')),
                path('admin/', admin.site.urls),
              ] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

main/views/ai_solutions.py
from django.shortcuts import render

import logging

from authentication.utils.check_login_state import check_login
from main.utils.ai_solutions_utils import *

logger = logging.getLogger(__name__)


def index(request):
    return render(request, 'main/index.html')


#@check_login
def ai_solutions(request, page):
    product_list, promotion_product_list, first_promotion_product, pagination = get_product(page)

    return render(request, 'main/ai_solutions.html',
                  {'product_list': product_list, 'promotion_product_list': promotion_product_list,
                   'first_promotion_product': first_promotion_product,
                   'promotion_product_num': range(len(promotion_product_list)),
                   'pagination': pagination})


#@check_login
def smart_curtain(request, page):
    product_list, promotion_product_list, first_promotion_product, pagination = get_product(page)
    load_animation = False
    if page == 1:
        load_animation = True

    return render(request, 'main/smart_curtain.html',
                  {'product_list': product_list,
                   'pagination': pagination,
                   'load_animation': load_animation})


#@check_login
def virtual_reality_forest_therapy(request, page):
    product_list, VR_product_list, first_promotion_product, pagination = get_VR_FT(page)
    
    return render(request, 'main/virtual_reality_forest_therapy.html',
                  {'product_list': product_list, 'VR_product_list': VR_product_list,
                   'first_promotion_product': first_promotion_product,
                   'promotion_product_num': range(len(VR_product_list)),
                   'pagination': pagination})

def digital_twin(request):
    return render(request,'main/VRFT_digital_twin.html')

def vr_detail(request):
    return render(request,'main/vr_detail.html')

main/views/consulting.py
import collections
from unicodedata import name
from attr import fields
from django import forms
from django.core.mail import send_mail
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, redirect, render
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView,DeleteView,CreateView
import logging
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from authentication.utils.check_login_state import check_login
from main.serializer import CartItemSerializer
from main.utils.ai_solutions_utils import *
from main.models import Cart, CartItem, Post
from main.models import Comment
from authentication.models import User
from rest_framework.views import APIView
from rest_framework.response import Response
#from authentication.form import CommentForm

logger = logging.getLogger(__name__)
def index(request):
    return render(request, 'main/consulting.html', {})

sort=0 
"""
0: regular 
1: reverse
2: hot
"""


class HomeView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(HomeView, self).get_context_data(**kwargs)
        context['object_list'] = context['object_list'][::-1]
        print(context)
        return context
        
    
#@method_decorator(check_login, name='dispatch')
class PostDetail(DeleteView):
    model = Post
    template_name = 'main/post_detail.html'

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        
        self.p = get_object_or_404(Post, id=self.kwargs['pk'])
        if not self.p.author:
            self.p.author = self.user
            # send post to our email
            send_mail(
                "Post update",
                f"Hello, \n\nThe user: {self.p.author.name}({self.p.author.email}) has shared a post.\nPost title: {self.p.title}\nPost content: {self.p.content}\nPlease check the detail at Smartplanting.net as admin.\n\nThank you!",
                "rundi.liu26@gmail.com",
                ["rundi.liu26@visionx.org"]
            )
        self.p.save()

        Comment.objects.filter(name=None).update(name=self.user.name)
        
        self.p.post_views = self.p.post_views + 1
        self.p.save()
        return super(PostDetail, self).dispatch(request, *args, **kwargs)
    
    def get_context_data(self, **kwargs):
        context = super(PostDetail, self).get_context_data(**kwargs)
        ob = get_object_or_404(Post, id=self.kwargs['pk'])
        num = ob.num_likes
        context["num_likes"] = num
        return context

#@method_decorator(check_login, name='dispatch')
class CreatePost(CreateView):
    model = Post
    template_name: str = 'main/create_post.html' # same w render(request, teplate_name)
    fields = ['title', 'image', 'content']

    def dispatch(self, request, *args, **kwargs):
        return super(CreatePost, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        return context

#@method_decorator(check_login, name='dispatch')
class AddComment(CreateView):
    model = Comment
    #form_class = CommentForm
    template_name = 'main/add_comment.html'
    fields = ['post', 'content']

    def get_context_data(self, **kwargs):
        context = super(AddComment, self).get_context_data(**kwargs)
        ob = get_object_or_404(Post, id=self.kwargs['pk'])
        context["form"].fields["post"].queryset = Post.objects.filter(title=ob.title, author=ob.author)
        return context
    
class Experts(ListView):
    model = Post
    template_name = 'main/experts.html'
    fields = '__all__'

class MyShare(ListView):
    model = Post
    template_name = 'main/my_share.html'

@check_login
def LikeView(request, pk):
    post = get_object_or_404(Post, id=request.POST.get('post_id')) # grab in detail html
    try:
        user = get_object_or_404(User, pk=request.session['user_id'])
    except:
        user = User.objects.get(name='Guest')
    if user not in post.likes.all():
        post.likes.add(user)
    else:
        post.likes.remove(user)
    return HttpResponseRedirect(reverse('main:post_detail', args=[str(pk)]))


class SortedView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(SortedView, self).get_context_data(**kwargs)
        return context

class ReverseView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(ReverseView, self).get_context_data(**kwargs)
        new_context = context
        new_context['object_list'] = new_context['object_list'].order_by('-date_added')
        return new_context

class HotView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(HotView, self).get_context_data(**kwargs)
        hot_context = context
        hot_context['object_list'] = hot_context['object_list'].order_by('-post_views')
        return hot_context

class CartView(APIView):
    
    def get(self, request):
        user = request.user
        cart = Cart.objects.filter(user=user,ordered=False).first()
        queryset = CartItem.objects.filter(cart=cart)
        serializer = CartItemSerializer(queryset, many=True)
        return Response(serializer.data)

    def post(self, request):
        data = request.data
        user = request.user
        cart, _ = Cart.objects.get_or_create(user=user, ordered=False)
        product = Product.objects.get(id=data.get('product'))
        price = product.price
        quantity = data.get('quantity')
        cart_items = CartItem(cart=cart, user=user, product=product, price=price, quantity=quantity)
        cart_items.save()

        cart_items = CartItem.objects.filter(user=user, cart=cart.id)
        cart.total_price = sum([i for i in cart_items])
        cart.save()

        return Response({'success': 'Items Added'})

    def put(self, request):
        data = request.data
        cart_item = CartItem.objects.get(id=data.get('id'))
        quantity = data.get('quantity')
        cart_item.quantity += quantity
        cart_item.save()
        return Response({'success': 'Items Updated'})

    def delete(self, request):
        user = request.user
        data = request.data
        cart_item = CartItem.objects.get(id=data.get('id'))
        cart_item.delete()
        cart = Cart.objects.filter(user=user, ordered=False).first()
        queryset = CartItem.objects.filter(cart=cart)
        serialier = CartItemSerializer(queryset, many=True)
        return Response(serialier.data)

@method_decorator(check_login, name='dispatch')
class shopping_carts(ListView):
    model = CartItem
    template_name = 'main/shopping_carts.html'

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        return super(shopping_carts, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = CartItem.objects.order_by('id')
        return super(shopping_carts, self).get_context_data(**kwargs)

main/views/plant.py
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView,UpdateView,CreateView,DeleteView
from django.core.mail import send_mail
from main.models import Plant
from authentication.models import User

class my_plants(ListView):
    model = Plant
    template_name = 'main/my_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        Plant.objects.filter(owner=None).update(owner=self.user)
        return super(my_plants, self).dispatch(request, *args, **kwargs)

class add_plants(CreateView):
    model = Plant
    template_name = 'main/add_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(add_plants, self).get_context_data(**kwargs)


class delete_plants(DeleteView):
    model = Plant
    template_name = 'main/delete_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']
    success_url = reverse_lazy('main:my_plants')

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(delete_plants, self).get_context_data(**kwargs)

class manage_plants(UpdateView):
    model = Plant
    template_name = 'main/manage_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(manage_plants, self).get_context_data(**kwargs)

def diagnoseView(request, pk):
    plant = get_object_or_404(Plant, pk=pk)
    plant.diagnose = True
    plant.save()
    send_mail(
        "Health Diagnosis",
        f"Hello, \n\nThe user:{plant.owner.name}({plant.owner.email}) has requested the health diagnosis for '{plant.name}',\nPlease check the detail at Smartplanting.net as admin.\n\nThank you!",
        "rundi.liu26@gmail.com",
        ["rundi.liu26@visionx.org"]
    )
    return HttpResponseRedirect(reverse('main:my_plants'))

main/templates/main/add_comment.html
{% extends "base.html" %}
{% load static %}
{% load filters %}
{% block resource %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/consulting.css' %}"/>
{% endblock %}
{% block title %}Comment On Post{% endblock %}
{% block head_script %}

{% endblock %}

{% block nav_brand %}
    <a class="navbar-brand" href="{% url 'main:index' %}" style="color: #dedede">SmartPlanting</a>
    <span class="vl"></span>
{% endblock %}

{% block nav_items %}
    <li class="nav-item">
        <a class="nav-link title1 active" href="{% url 'main:consulting' %}">Consulting</a>
    </li>
    <li class="nav-item">
        <a class="nav-link title2" href="{% url 'main:create_post' %}">New Post</a>
    </li>
{% endblock %}

{% block content %}
<div>
<div
    style="margin-left: auto;margin-right: auto;">
    
    <ul>
        <br/>
        <h1 style="text-align:center">
            Adding Comment...
        </h1>


        <br/>
        <br/>
        <div class="form-group" style="text-align:center">
        <form method="POST">
        {% csrf_token %}
        {% for field in form %}
        {{ field.label_tag }}
        <div class="fieldWrapper">
            {{ field.errors }}
             {{ field }}
            <br/>
            <br/>
        </div>
        {% endfor%}
            <button>Add Comment</button>
        </form>
        <br/><br/>
        <a href="{% url 'main:consulting' %}">Cancel</a>
        </div>

        
    </ul>
</div>
{% endblock %}

main/templates/main/consulting.html
{% extends "base.html" %}
{% load static %}
{% load filters %}
{% block resource %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/consulting.css' %}"/>
{% endblock %}
{% block title %}Consulting{% endblock %}
{% block head_script %}

{% endblock %}

{% block nav_brand %}
    <a class="navbar-brand" href="{% url 'main:index' %}" style="color: #dedede">SmartPlanting</a>
    <span class="vl"></span>
{% endblock %}

{% block nav_items %}
<li class="nav-item">
    <a class="nav-link title1 active" href="{% url 'main:consulting' %}">Consulting</a>
</li>
    <a class="nav-link title2" style="margin-left: 20%;" href="{% url 'main:create_post' %}">New Post</a>
    <a class="nav-link title2" style="margin-left: 20%;" href="https://visionx.org/teams.html">Our Experts</a>
    
    
{% endblock %}

{% load tz %}

{% block content %}
<!--style="background-image:linear-gradient(to right, rgba(26, 188, 156, 1) 0%, rgba(142, 68, 173, 1) 100%);-->
<div>
<br/>
<div class="container">
    
    <ul>
        <tr>
            <h2>Welcome {{request.session.username}} !</h2>
            <small>Want to share or ask questions? Create your post here👉<form style="display:inline-block;" action="{% url 'main:create_post' %}">
            <button style="box-shadow: 0 0 30px 0 rgba(26, 188, 156, 1),0 0 30px 0 rgba(26, 188, 156, 1),0 0 10px 0 rgba(26, 188, 156, 1) inset;background-color: unset;">New Post</button> </form></small>
            
            <div style="text-align: right;">
                <strong>Sort By</strong> : 
                <a style="background-color: unset; color: unset;" class="btn btn-primary" href="{% url 'main:reverse_post' %}">Newest to Oldest</a>
                
                <a style="background-color: unset; color: unset;" class="btn btn-primary" href="{% url 'main:hot_post' %}">Hot</a>
                
                <a style="background-color: unset; color: unset;" class="btn btn-primary" href="{% url 'main:sorted_post' %}">Oldest to Newest</a>
                
            </div>

            <HR style="FILTER: alpha(opacity=0,finishopacity=100,style=1)" width="100%" color=#987cb9 SIZE=3>
            
            {% for post in object_list %}
            
            <div class="card" style="background-color:unset">
                    <div class="card-header">
                    <h3><a
                    style="color:black;text-decoration: none"
                    href="{% url 'main:post_detail' post.pk %}">{{post.title}} 
                    {%if post.num_likes > 0 %}
                    <img style="height:33px; float:right; display: inline-block;" src="/media/like_images.png">
                    {% endif %}
                    
                    </a></h3>
                    </div>
                
                    <div >
                        &nbsp;
                    <small>
                    
                    
                    Likes:<i> {{post.num_likes}}</i>
                    &nbsp;&nbsp;<strong>|</strong>&nbsp;&nbsp;
                    Comments:<i>{{post.num_comments}}</i>
                    &nbsp;&nbsp;<strong>|</strong>&nbsp;&nbsp;
                    Views:<i> {{post.post_views}}</i>
                    &nbsp;&nbsp;<strong>|</strong>&nbsp;&nbsp;
                    Created by:<i> {{ post.author }}</i>
                    <div style="float:right; display: inline-block;">
                    Created at:<i> {{ post.date_added|utc }}(UTC)</i> </div>
                    </small>
                <!--<HR style="FILTER: alpha(opacity=0,finishopacity=100,style=1)" width="96%" color=#987cb9 SIZE=3>
                -->
                    </div>
                </div>
                <br/>
        </tr>
            
        {% endfor %}
        <br/><br/>
    </ul>
</div>
{% endblock %}

main/templates/main/my_plants.html
{% extends "base.html" %}
{% load static %}
{% block resource %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/index.css' %}"/>
	<link rel="stylesheet" href="https://unpkg.com/tailwindcss@2.2.19/dist/tailwind.min.css"/> 
{% endblock %}
{% block title %}SmartPlanting{% endblock %}

{% block nav_brand %}
    <a class="navbar-brand active" href="{% url 'main:index' %}">SmartPlanting</a>
    <span class="vl hide-vl"></span><br>
{% endblock %}

{% block nav_items %}
    <li class="nav-item">
        <a class="nav-link title1" href="{% url 'main:ai_solutions' 1 %}">AI Solutions</a>
    </li>
    <li class="nav-item">
        <a class="nav-link title1" href="{% url 'main:consulting' %}">Consulting</a>
    </li>
    <li class="nav-item">
        <a class="nav-link title1" href="#">Third Party</a>
    </li>
{% endblock %}

{% block content %}
<script>
	function clickAlert() {
	  alert("Request submitted!\nOur Experts will diagnose and contact you as soon as possible!");
  }
</script>


<body style="background-color:#f5f5f5" class="font-sans antialiased text-gray-900 leading-normal tracking-wider bg-cover" >

	<br/><br/>
	<a class="bg-green-700 hover:bg-green-900 text-white font-bold py-2 px-4 rounded-full" href="{% url 'main:add_plants' %}" >
		Add new plant
	</a> 
	{% for plant in object_list %}
			{% if plant.owner.name == request.session.username %}
	<div class="max-w-4xl flex items-center h-auto lg:h-screen flex-wrap mx-auto my-32 lg:my-0">
	  <!--Main Col-->
	  <div id="profile" class="w-full lg:w-3/5 rounded-lg lg:rounded-l-lg lg:rounded-r-none shadow-2xl bg-white opacity-75 mx-6 lg:mx-0">
		  <div class="p-4 md:p-12 text-center lg:text-left">
			  <!-- Image for mobile view-->
			  <div class="block lg:hidden rounded-full shadow-xl mx-auto -mt-16 h-48 w-48 bg-cover bg-center"></div>
			  <h1 class="text-3xl font-bold pt-8 lg:pt-0">{{plant.name}}</h1>
			  
			
			<br/>
			  <form action = "{% url 'main:diagnose' plant.pk %}" method="POST">
				<a class="bg-green-700 hover:bg-green-900 text-white font-bold py-2 px-3 rounded-full" href="{% url 'main:manage_plants' plant.pk %}">Manage my plant</a>
				{% csrf_token %}
				<button type="submit" class="bg-green-700 hover:bg-green-900 text-white font-bold py-1.5 px-3 rounded-full" onclick="clickAlert()">Health diagnosis</button>
				<a class="bg-green-700 hover:bg-green-900 text-white font-bold py-2 px-3 rounded-full" href="{% url 'main:delete_plants' plant.pk %}">Delete</a>
				{% csrf_token %}
			 </form>
			 
			  <p class="pt-4 text-sm"> <strong>Category: </strong> {{plant.category}} </p>
			  <p class="pt-4 text-sm"> <strong>Age: </strong> {{plant.age}} years </p>
			  <p class="pt-4 text-sm"> <strong>Health Condition: </strong>{{plant.health}}</p>
			
		  </div>
		  
	  </div>
	  
	  <!--Img Col-->
	  <div class="w-full lg:w-2/5">
		<br/>
		<div style="width: 500px; height: 300px;">
		  <!-- Big profile image for side bar (desktop) -->
		  <img src="{{plant.image.url}}" style="height: 92%; width: 90%;" class="rounded-none lg:rounded-lg shadow-2xl hidden lg:block">
		  <!-- Image from: http://unsplash.com/photos/MP0IUfwrn0A -->
		  
		</div>
	  </div>
	  
  </div>
  
	  <script src="https://unpkg.com/popper.js@1/dist/umd/popper.min.js"></script>
	  <script src="https://unpkg.com/tippy.js@4"></script>
	  <script>
		  //Init tooltips
		  tippy('.link',{
			placement: 'bottom'
		  })
  
		  //Toggle mode
		  const toggle = document.querySelector('.js-change-theme');
		  const body = document.querySelector('body');
		  const profile = document.getElementById('profile');
		  
		  
		  toggle.addEventListener('click', () => {
  
			if (body.classList.contains('text-gray-900')) {
			  toggle.innerHTML = "☀️";
			  body.classList.remove('text-gray-900');
			  body.classList.add('text-gray-100');
			  profile.classList.remove('bg-white');
			  profile.classList.add('bg-gray-900');
			} else
			{
			  toggle.innerHTML = "🌙";
			  body.classList.remove('text-gray-100');
			  body.classList.add('text-gray-900');
			  profile.classList.remove('bg-gray-900');			
			  profile.classList.add('bg-white');
			  
			}
		  });
		  
	  </script>
	  
	  {%endif%}
  {%endfor%}
  </body>
{% endblock %}

main/templates/main/post_detail.html
{% extends "base.html" %}
{% load static %}
{% load filters %}
{% block resource %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/consulting.css' %}"/>
{% endblock %}
{% block title %}Post Detail{% endblock %}
{% block head_script %}
   
{% endblock %}

{% block nav_brand %}
    <a class="navbar-brand" href="{% url 'main:index' %}" style="color: #dedede">SmartPlanting</a>
    <span class="vl"></span>
{% endblock %}

{% block nav_items %}
    <li class="nav-item">
        <a class="nav-link title1 active" href="{% url 'main:consulting' %}">Consulting</a>
    </li>
    <li class="nav-item">
        <a class="nav-link title2" href="{% url 'main:create_post' %}">New Post</a>
    </li>
{% endblock %}

{% block content %}
<div>

<div
    style="margin-left:15%;margin-right:15%;"
    <ul>
        <h2
            style="text-align: center; font-size:45px">
                {{ post.title }}
        </h2>
        <div>
            <small>
            
            <div style="display:inline-block; text-align: center; width: 100%;">
                <small> Views: {{post.post_views}} </small> | 
                <small> Comments: {{post.num_comments}} </small> | 
                <small> Author: {{post.author}} </small> |
                <small> Date: {{post.date_added}}(UTC) </small>
            </div>

            </small>
        </div>
        <HR style="FILTER: alpha(opacity=0,finishopacity=100,style=1)" width="100%" color=#987cb9 SIZE=3>
        <br/> 
        <br/>

        {% if post.image %}
        
        <img style="display: block; margin-left: auto;margin-right: auto; width: 50%;" src = "{{ post.image.url }}">
        <br/><br/>
        {% endif %}
        
        <h3 style="display:contents; font-size:23px;font-family:verdana"> {{ post.content|linebreaks }} </h3>
        <br/>
         
        <HR style="FILTER: alpha(opacity=0,finishopacity=100,style=1)" width="100%" color=#987cb9 SIZE=3>
        
        <br/>
        
        <form action = "{% url 'main:like_post' post.pk %}"
        method="POST">
        {% csrf_token %}
        <button type="submit" src="/media/like_images.png" name="post_id" class="btn btn-primary btn-sm" value="{{ post.id }}" /> 
        {% for user in post.likes.all %}
            {% if user.name == request.session.username %}
                Cancel
            {% endif %}
        {% endfor %}
        like
        </button>
        -
        <img style="height:25px;display: inline-block;" src="/media/like_images.png">
        {{ num_likes }} 
        Likes
        
        </form>
        <br/><br/>
        <h1 style="text-align: center;color:white;background-color:#114934">
            Comments......
        </h1>
        <br/>
        {% if not post.comments.all %}
                No Comments Yet... Be the first to comment on this
                <br/><a href="{% url 'main:add_comment' post.pk %}">Add Comment</a>
        {% else %}
            
            <br/>
            <div style="display:inline-block; width: 1000px; height: 600px;">
                {% for comment in post.comments.all %}
                
                <img style="float:left; display: block; height: 15%; width: 9%; border-radius: 50%;" src = "{{comment.get_user.profile.url}}"><br/>
            
                <strong>
                    &nbsp {{comment.name}}<br/>
                    &nbsp {{comment.date_added}}
                </strong>
                <hr>
                <br/>
                {{comment.content|linebreaks}}
                <br/>
                <br/>
                
                {% endfor %}
            </div>
                <!--
                    <a href="{% url 'main:add_comment' post.pk %}"><div style="text-align:center">
                    Add Comment
                </div>
                -->
                <br/><br/>
                <a href="{% url 'main:add_comment' post.pk %}">Add Comment</a>
                
        {% endif %}
        

        <br/><br/><br/><br/>
        <a href="{% url 'main:consulting' %}">Back</a><br/><br/>
    </ul>
</div>
{% endblock %}